/********************************************************
Workspace: IAR_ARM+SPL
MCU      : STM32f050f4/6
Project  : 
Version  :
Date     : NOV 2019
*********************************************************/

#include <stm32f0xx.h>
#include <stdbool.h>
#include <uchar.h>

#include "stm32f0xx_syscfg.c"
#include "stm32f0xx_gpio.c"
#include "stm32f0xx_dma.c"
#include "stm32f0xx_rcc.c"
#include "stm32f0xx_iwdg.c"
#include "stm32f0xx_pwr.c"

#include "bitset.c"
#include "defines.c"
#include "periph_cfg.c"
#include "psu_mon.c"
#include "kb.c"
#include "beep.c"
#include "interrupts.c"

void main()
{
 enable_PVD();
 while(PWR_GetFlagStatus(PWR_FLAG_PVDO)==SET) continue; //Vdd < PVD trs
 disable_PVD();

 cfg_rcc();
 cfg_gpio();
 cfg_t1();
 cfg_t2();
 cfg_tim14();

 btn_init();



 __enable_interrupt();

 ENDLESS
 {

  __WFI();
 }
}
